package circularlist;

import java.util.Objects;

public class CircularList {
	private Object[] elements;
	private int index = -1;

	public CircularList(Object... elements) {
		this.elements = elements.clone();
	}

	/** get the element at index i % size(). */
	public Object get(int i) {
		return elements[i % elements.length];
	}

	/**
	 * return the first index of the object o in the circular list, -1 if the object
	 * is not present.
	 * @throws ObjectMissingException 
	 */
	public int indexOf(Object o) throws ObjectMissingException {
		for (int i = 0; i < elements.length; i++) {
			if (Objects.equals(elements[i], o))
				return i;
		}
		throw new ObjectMissingException(o);
	}

	/** number of elements contained in the circular list. */
	public int size() {
		return elements.length;
	}

	public Object nextElement() {
		index = ++index % elements.length;
		return elements[index];
	}

	public String toString() {
		return "Circular list of size " + size();
	}
}